Subject: Possible OBF question -- I18n

From: John C Klensin <[email-masked]>
Date: Wed, 30 May 2018 15:55:24 -0400

Hi.

I want to share a question and possible an idea and see if it
gets any traction before Thursday's BOF application cutoff.

Many people seem to think that what has come to be called
"internationalization" ("i18n") of the Internet is important,
both to serving existing users for whom English may not be a
comfortable language or Lain script a comfortable writing system
and to making the Internet accessible to much larger populations
("the next billion").   Some of the issues are related to
identifiers, with examples including IDNA, IRIs, PRECIS, and the
recent work on non-ASCII identifiers in certificates.  Others
are more connected to actual protocol design, such as the
SMTPUTF8 work in the EAI WG.   Still others are related to
content, language selection ins various applications, and so on.

I think there is general recognition that the problems are
difficult.  Human languages have evolved, and evolved
differently, over more centuries than anyone can count, making
extrapolations from one language or writing system to another
difficult and error-prone.  Conventions that evolved to permit
use of typewriters (with mechanically-limited numbers of keys)
with writing systems with more than that many characters haunt
contemporary comparison and matching issues.  Even changes as
recent as the divergence of American from British English,
French as spoken and written in France from French as used in
Quebec, and efforts to simplify the representations of a few
thousand commonly-used Chinese characters can pose serious
problems for computer system designers and implementers who just
want do do something quick, obvious, and straightforward but
still correct (or at least acceptable enough to not be
culturally insulting).

At the same time, the IETF has a problem with expertise, real
energy, and support for internationalization work.  The last WGs
directly focused on the issues have essentially run out of
steam, with a very small number of participants able and willing
to do late-stage analysis and reviews.  Other WGs whose work has
involved important I18n issues have recognized that they don't
have the needed expertise and had some trouble recruiting it or,
when we are less lucky, have not recognized the problem.  The
latter poses a special challenge because, if the work is
specialized, there may be little or no review of the I18n impact
during IETF Last Call unless someone happens to notice, a
sitaution that might pose a real threat to interoperability when
the protocols are actually used.

In addition, pressing problems do show up about which decisions
need to be made if the IETF is going to fulfill its
responsibilities in this area and, because of concerns about
reviews (and probably more), it seems impossible to process work
that is necessarily standards track without a WG and impossible
to create a WG given the absence of manifestations of broad
interest and knowledge and the history, mentioned above, of WGs
running out of steam.

It also probably doesn't help that several of the acknowledged
experts and critically interested parties have little or no
reliable support for attending IETF meetings so, if a group is
to be judged by counting the number of people in the room for a
discussion, it is easy to conclude that there is less interest
than might actually exist.

Some of us have been waiting for the IESG and/or IAB to sort the
situation out and tell us what to do.  That hasn't happened,
possibly because flying pigs are in short supply but more likely
because they understand the problems and don't have any
solutions either.  The IAB's concluding almost a year ago that
its I18n Program was unsustainable and closing it was probably a
benchmark, especially when one notices that no substitute has
emerged, but, even had that not happened, an IAB Program can't
process standards track documents under our current rules (or
any rules I see anyone rushing to propose).

So I'm wondering whether there is sufficient interest to hold a
BOF to discuss how to deal with this situation.   I don't want
to get into the many substantive issues that have been hanging
around, but rather to address the question of how, if there were
drafts, what the review and approval process should be in an
IETF where there will probably never be a huge number of experts
around with time on their hands.  Could we devise something
Directorate-like or even Area-like?  Could that group be counted
on for substantive/ technical reviews to the extent to which,
even if no other reviews addressed the substantive subject
matter and no one on the IESG had special expertise, they could
be approved anyway?  Should we be reaching out to other groups
with general internationalization expertise (not just, or a
focus on, character coding) to see if we would work out joint
review efforts or even if we could comfortably export the topic?
Or have we actually come to the conclusion that the IETF had
best stop claiming any responsibility or authority in this area
and that we are willing to let whatever emerges fill the vacuum?

If this sounds useful and you have anything to contribute,
especially procedural or "where do we find the experts" advice,
please speak up within the next 24-48 hours.  IMO, if we should
give give up, I think it would be better to do that as the
result of a formal discussion than as a decision of a handful of
people meeting more or less in private and without an explicit
opportunity for community input.  

    john

p.s. before someone asks, I'm thinking actual BOF because don't
think there is any point in this unless it has someone from the
IESG willing to take at least some responsibility, produces
minutes, has meetecho coverage, etc.   I don't think dancing
around with Bar BOFs, non-bar Bar BOFs, informal meetings, etc.,
meet those criteria.  I don't thing a presentation in an area
meeting or two would do it either -- we've tried that with no
success and, more important, I'm seeing an increasing number of
WGs being created with i18n implications or necessary
involvement that are not in the ART area.

---

From: "John Levine" <[email-masked]>
Date: 30 May 2018 19:11:26 -0400

>please speak up within the next 24-48 hours.

I'm certainly interested and agree that a BOF makes sense if there are
more than the two of us there.

I'm also in the willing to do the work if there were someone who would
pay me to do it camp.

R's,
John

---

From: John C Klensin <[email-masked]>
Date: Wed, 30 May 2018 22:56:58 -0400

(obvious subject line type corrected -- more below)

--On Wednesday, May 30, 2018 19:11 -0400 John Levine
<[email-masked]> wrote:

>> especially procedural or "where do we find the experts"
>> advice, please speak up within the next 24-48 hours.
> 
> I'm certainly interested and agree that a BOF makes sense if
> there are more than the two of us there.
> 
> I'm also in the willing to do the work if there were someone
> who would pay me to do it camp.

What work?  

I could say exactly the same thing and would certainly be able
to put a lot more energy into i18n issues if I had any support
for that work at all.  

However, I note that various combinations of Asmus Freytag,
Patrik Fältström, Andrew Sullivan, and I have produced drafts
that relate to at least the IDN parts of the problem (some of
them also have PRECIS implications) and have let them expire
because there appeared to be no way to get them processed.  I
also note that Peter St. Andre finished up the initial PRECIS
docs and then a set of revisions with very little input or
review from the community.

I don't know where the day jobs or other sources of support of
any of those people fall on a scale between "strongly support
and expect" and "tolerate, mostly on your own time" where IETF
i18n work is concerned, but I suspect it is closer to the latter
for at least most.  In my case, I've had zero specific support
for i18n work in the IETF in over a decade (and that includes
the time when I was writing documents for, and then co-chairing,
EAI.    I also know that the IAB made some statements some years
back that appeared to be commitments to find resources for this
work and that nothing every happened and that I've been told by
several sources that finding companies willing to put major
resources into this area is _very_ hard.  So making a plan that
is continent on someone showing up with a pot of money seems
unwise.

So my alternate hypothesis and reason for floating the BOF idea
starts by assuming that, whether people can find some small
amount of support or are dumb and/or committed enough to do the
work anyway, the needed documents can and will be written and
hence that the problem is getting adequate review to convince
the IESG and the IETF community that those documents have been
sufficiently checked and vetted to make publication --including
as standards track when appropriate -- plausible and a
reasonable expectation.

best,
   john

---

From: "Patrik Fältström" <[email-masked]>
Date: Thu, 31 May 2018 08:27:20 +0200

On 31 May 2018, at 4:56, John C Klensin wrote:

> So my alternate hypothesis and reason for floating the BOF idea starts by assuming that, whether people can find some small
> amount of support or are dumb and/or committed enough to do the work anyway, the needed documents can and will be written and hence that the problem is getting adequate review to convince the IESG and the IETF community that those documents have been sufficiently checked and vetted to make publication --including as standards track when appropriate -- plausible and a
> reasonable expectation.

The serious question here is if IETF do have enough competence in I18N space or if IETF should drop that ball and give to some other SDO.

   Patrik

---

From: "John R Levine" <[email-masked]>
Date: 31 May 2018 09:37:35 -0400

> The serious question here is if IETF do have enough competence in I18N space or if IETF should drop that ball and give to some other SDO.

But the related question is whether any other SDO is any better.

I18N needs an unusual combination of computer and linguistic skills.  I 
would be surprised if there were a lot of any people anywhere who have 
them both.

Regards,
John Levine, [email-masked], Taughannock Networks, Trumansburg NY
Please consider the environment before reading this e-mail. https://jl.ly

---

From: John C Klensin <[email-masked]>
Date: Thu, 31 May 2018 09:51:14 -0400

--On Thursday, May 31, 2018 08:27 +0200 Patrik Fältström
<[email-masked]> wrote:

>> So my alternate hypothesis and reason for floating the BOF
>> idea starts by assuming that, whether people can find some
>> small amount of support or are dumb and/or committed enough
>> to do the work anyway, the needed documents can and will be
>> written and hence that the problem is getting adequate review
>> to convince the IESG and the IETF community that those
>> documents have been sufficiently checked and vetted to make
>> publication --including as standards track when appropriate
>> -- plausible and a reasonable expectation.
> 
> The serious question here is if IETF do have enough competence
> in I18N space or if IETF should drop that ball and give to
> some other SDO.

I think that leads to two other questions that I've at least
been hinting at.  

(1) If that is the right answer, how do we make it?  Personally,
I don't want to hear it via an announcement that the IEASBG
decided, entered into some sort of negotiation, and is telling
the community what they have done.

(2) Did you have a candidate SDO in mind?  Without any
disrespect to the SDOs or people involved with them, I think
we've seen ample evidence that, e.g., an SDO that is primarily
concerned with character coding and closely-related issues is
unlikely to be willing and able to understand complex issues
with the Internet and Internet protocols and prioritize them in
a way we would find acceptable.  One clear example of that
involves whether identifiers can actually be
language-insensitive.   Perhaps the answer is actually "no" but,
if so, we have made a number of bad protocol decisions that will
need to be untangled if things are ever going to work well and
I'd be surprised if it would be wise, or the IETF would be
willing, to hand those off.  Consider the DNS, identifiers for
messaging protocols, X.509 certificate identifiers, email
addresses, and so on.

--On Thursday, May 31, 2018 09:37 -0400 John R Levine
<[email-masked]> wrote:
 
> I18N needs an unusual combination of computer and linguistic
> skills.  I would be surprised if there were a lot of any
> people anywhere who have them both.

I think the list may be longer than that, with both human and
artificial interaction design (including UI, but not limited to
UI design) high on the list.   Given industry trends in user
input, especially on mobile platforms, probably speech
recognition too.   Probably you include those in "computer
skills", but I think spelling it out a bit more makes the
problem more clear.

Maybe it is a strange idea, but, if someone is going to screw up
the Internet in this area, I'd rather have it be the IETF than
some body whose major concerns in practice are not a better
Internet (whether those concerns are a particular technical
focus or economics).

I could see a "joint development" collaboration between the IETF
and some other SDO(s) working together and cross-checking each
other's work --not merely cross-area, but cross-SDO-- but that
IETF has never been able to pull one of those off before and,
AFAIK, has never expressed much interest in doing so.  Even if
we went that route, we might need a different review mechanism
than throwing a spec into the air with an IETF LC and seeing
what came down.

    john

---

From: "Patrik Fältström" <[email-masked]>
Date: Thu, 31 May 2018 17:02:15 +0200

> But the related question is whether any other SDO is any better.

+1

Or that just thinking of moving things away from IETF would create dependencies we do not like, so that people, organizations and other participants start prioritize differently?

> I18N needs an unusual combination of computer and linguistic skills.  I would be surprised if there were a lot of any people anywhere who have them both.

I know there are more than the three four five that normally respond to things. I think to start with we talk about coordination and prioritization so that we get this, although small, group of people more effective.

I hope that would bring the interest up to speed enough to make it possible for IETF (and IAB) say we (as in the SDO) do have enough skills in this area to make good decisions. I.e. consensus is possible to conclude, and we trust the outcome of the "normal" IETF consensus based process.

And, to conclude, having a BOF to talk about this is I think excellent.

    paf

---

From: "Patrik Fältström" <[email-masked]>
Date: Thu, 31 May 2018 17:05:10 +0200

On 31 May 2018, at 15:51, John C Klensin wrote:

> I think that leads to two other questions that I've at least been hinting at.

Exactly...

   paf

---

From: "tom p." <[email-masked]>
Date: Thu, 31 May 2018 16:31:37 +0100

----- Original Message -----
From: "John R Levine" <[email-masked]>
Sent: Thursday, May 31, 2018 2:37 PM

> > The serious question here is if IETF do have enough competence in
I18N space or if IETF should drop that ball and give to some other SDO.
> would be surprised if there were a lot of any people anywhere who have

John,

I have always seen the centre of gravity of i18n as firmly in Europe.  I
recall the struggles 40 years ago to persuade American organisations to
take it seriously; I have always seen ASCII as an American response
to the issue.

Most of what I have learnt since comes from people who appear, from
their affiliation, to be centred in Europe so I am not surprised that
i18n efforts in the IETF do not reach as satisfactory a conclusion as
some other work since the IETF has long had a closer connection with
North America than other regions of the world.

So where should the work take place?  In a Europe-centric organisation,
perhaps the EU (who put a lot of effort into some fields of IT), the ITU
(which after all does recognise languages other than American in its
work) or some such; and then there is Unicode which represents a certain
competence in this area:-)

I have wondered if the focus for this work would shift to the CJK parts
of the world, as they became more engaged in mainstream IT, since
European code page issues seem trivial compared to those of CJK, but I
have not detected any such movement; Europe still seems to be the most
concerned with this issue and so most likely to put effort into
progress.

Tom Petch

---

From: "John R Levine" <[email-masked]>
Date: 31 May 2018 12:32:06 -0400

> take it seriously; I have always seen ASCII as an American response

All the work I've done recently has been with people from India and China. 
There is a lot of interest in EAI in India since apparently one of the 
states is planning to give out e-mail accounts to go with the Aadhaar IDs.

Personally I don't care where we do it so long as competent people show 
up.

Regards,

---

From: John C Klensin <[email-masked]>
Date: Thu, 31 May 2018 13:08:31 -0400

--On Thursday, May 31, 2018 16:31 +0100 "tom p."
<[email-masked]> wrote:

> I have always seen the centre of gravity of i18n as firmly in
> Europe.  I recall the struggles 40 years ago to persuade
> American organisations to take it seriously; I have always
> seen ASCII as an American response to the issue.

Actually, while I can't speak for what you see, the centre (sic)
of gravity changed around two decades ago and that (Western,
Latin-script-using) European orientation turned into a problem
as people using that script assumed that the issues associated
with their languages were the hard ones and that they could
think about everything else in those terms.  Our colleagues in
Asia (eastern and western), parts of Africa, and probably
elsewhere, know better, including knowing about scripts whose
characters are always written in connected form, that may have
right to left or top to bottom characteristics, that have very
different conventions about punctuation and word and sentence
separation than Latin and closely-related scripts, and so on
(that is definitely not a complete list).   The impetus for IDN
work came from East and Southeast Asia, not Europe, and other
examples abound.   

There are active IETF participants whose daily work and/or
family lives include use of Arabic script (in both Arabic
language and Persian-derived variations), Chinese script,
Cyrillic, Hebrew script, Korean Hangul, scripts and writing
systems of the Indian Subcontinent, and others I apologize for
not being able to think of at the moment.  At least as much
pressure is, or should be, coming from them as from those who
merely need a handful or what we sometimes call decorated Roman
letters.

  There is very serious work on internationalization in China,
India, Israel, Japan, Russia, Ukraine, a number of
Arabic-speaking countries, and others I either don't know about
or that don't come to mind at the moment.

> Most of what I have learnt since comes from people who appear,
> from their affiliation, to be centred in Europe so I am not
> surprised that i18n efforts in the IETF do not reach as
> satisfactory a conclusion as some other work since the IETF
> has long had a closer connection with North America than other
> regions of the world.
> 
> So where should the work take place?  In a Europe-centric
> organisation, perhaps the EU (who put a lot of effort into
> some fields of IT), the ITU (which after all does recognise
> languages other than American in its work) or some such; and
> then there is Unicode which represents a certain competence in
> this area:-)

I don't want to start a conversation about specific
organizations here, but each of those you mention has what I
believe the IETF would conclude has an unattractive track record
where internationalization is considered broadly in an Internet
context.  Note too that decisions to work in multiple languages
(and the ability to execute on those decisions) is very
different from decisions to develop protocols that function well
in many (or all) languages and, as I said earlier, while coding
is critically important, it is not all of the problem or even
most of it.

> I have wondered if the focus for this work would shift to the
> CJK parts of the world, as they became more engaged in
> mainstream IT, since European code page issues seem trivial
> compared to those of CJK, but I have not detected any such
> movement; Europe still seems to be the most concerned with
> this issue and so most likely to put effort into progress.

Interesting.  I suggest you have been looking in the wrong
places, even about participants in the IETF.

     best,
     john

---

From: Nico Williams <[email-masked]>
Date: Thu, 31 May 2018 12:22:29 -0500

On Thu, May 31, 2018 at 08:27:20AM +0200, Patrik Fältström wrote:
> The serious question here is if IETF do have enough competence in I18N
> space or if IETF should drop that ball and give to some other SDO.

Does anyone else?!

Certainly, in the context of Internet protocols, the IETF is the place
to do I18N work.  Can there be any doubt?

I mean, no SDO has more competence than the Unicode Consortium when it
comes to dealing with core Unicode issues alone.

But there are protocol issues in the I18N and L10N spaces where the IETF
has the most competence, IMO.

In any case, if the proposal is to do I18N work on protocols that are
not Internet protocols, then I would say: no.  Bring those protocols
into the IETF or leave them out -- that's the only choice there, but if
we bring them in then we must also do any necessary I18N work on them.

Lack of expertise is not a problem: we can develop it, and we can seek
out external review.

Besides, the IETF has lots of I18N expertise on hand.  Perhaps the IETF
has no energy to do I18N work, but that's another story.

Nico
--

---

From: Peter Saint-Andre <[email-masked]>
Date: Thu, 31 May 2018 11:28:15 -0600

On 5/31/18 11:22 AM, Nico Williams wrote:

> Lack of expertise is not a problem: we can develop it, 

We have not yet had success with developing expertise, or even
competence. However, this is something we could discuss at the BoF.

Peter

---

From: Donald Eastlake <[email-masked]>
Date: Thu, 31 May 2018 14:04:51 -0400

Hi,

On Thu, May 31, 2018 at 9:51 AM, John C Klensin <[email-masked]> wrote:
> ...

I disagree. I was co-chair of the joint IETF/W3C XMLDSIG WG which I
believe was reasonably successful.

Thanks,
Donald
===============================
 Donald E. Eastlake 3rd   +1-508-333-2270 (cell)
 155 Beaver Street, Milford, MA 01757 USA
 [email-masked]

---

From: John C Klensin <[email-masked]>
Date: Thu, 31 May 2018 14:24:16 -0400

--On Thursday, May 31, 2018 12:22 -0500 Nico Williams
<[email-masked]> wrote:

> Lack of expertise is not a problem: we can develop it, and we
> can seek out external review.

Nico, this isn't clear to me.  We've been talking about
developing more expertise for years and nothing has happened, in
part because there seems to be little support for those who
would like to acquire the expertise (or career advantages if
they do).   We've also talked on and off for years about
external review but that has not gone anywhere either, partially
because, unless the IESG has internal expertise, it is hard to
determine which external reviewers to believe and how much...
and external review is not a substitute for IETF consensus unles
the IETF community says it is, which we haven't.

> Besides, the IETF has lots of I18N expertise on hand.

I'd question that too.  Certainly we've seen many people stand
up in i18n-related discussions and make very broad statements
based on their knowledge of a couple of languages or even a
couple of scripts, and assuming that knowledge applies to, and
makes them expert on, everything else.  I see that as part of
the problem, even if if only as a cause of lack of energy, but
not as a sign of expertise.  I do see people with expertise not
participating and taking leadership roles (or starting and then
dropping out) because the noise level is just too daunting.

>  Perhaps the IETF has no energy to do I18N work, but that's
> another story.

It should be.  I didn't distinguish it strongly enough in my
note because I'm not sure we know how to tell the difference.   

Perhaps an example will help.  Let's say we charter a WG that is
solely focused on some particular issue in, say, routing.  We
have a strong community expectation that people with little or
no background knowledge in routing principles and prior work in
routing on the Internet will either not show up or will remain
quiet and try to learn.  When those expectations are violated,
we have a vocabulary for talking about the offenders (starting
with "troll") and assorted mechanisms for constraining their
ability to disrupt discussions among experts and, while we hope
that effort to keep the discussions focused will avoid tipping
over into harassment or personal attacks, few people consider
that making sure expertise dominates the discussions to be
inappropriate.

Now compare recent IETF i19n-related WG work.  EAI was chartered
because there was a clear expectation that, if the IETF didn't
do something and do it at least fairly well, we would end up
with a non-interoperable mess and because there were people who
wanted to do the work.  But, while the topic, which involved
some rather complex issues with email and transition models as
well as well as i18n ones and specific interests from specific
language groups, didn't have the same expectations as that
hypothetical routing WG -- "I use email and therefore understand
it' or "I use a language that requires a non-ASCII script"
seemed to be adequate conditions for participation.   Now (I'm
certain no thanks to my tenure as co-chair) that worked out
rather well.  I think a lot of people learned things about what
they didn't know and then proceeded to acquire at least enough
knowledge to fill in the gaps to allow intelligent
conversations.  And the WG came up with a collection of
protocols that have been (and are being) deployed with none of
the experience yet indicating we got anything seriously wrong.
But, at least IMO, it was very painful, some people with
significant expertise on at least one of the topic areas dropped
out, and, by the time the WG was ready to conclude, the number
of people actively doing work was small enough that it is
unlikely that, had that been the level of participation from the
beginning, the WG would have ever been chartered.

A different version of the reason I am wondering whether a BOF
would be useful is, as Peter suggested about one of the
subtopics, to address exactly that pattern and how we get
unstuck from it.

best,
    john

---

From: John C Klensin <[email-masked]>
Date: Thu, 31 May 2018 14:25:20 -0400

Don,

Thanks.  Had forgotten that one.   The fact that there are
successful precedents is definitely good news.

   john

--On Thursday, May 31, 2018 14:04 -0400 Donald Eastlake
<[email-masked]> wrote:

>> I could see a "joint development" collaboration between the
>> IETF and some other SDO(s) working together and
>> cross-checking each other's work --not merely cross-area, but
>> cross-SDO-- but that IETF has never been able to pull one of
>> those off before and, AFAIK, has never expressed much
>> interest in doing so.  Even if
> 
> I disagree. I was co-chair of the joint IETF/W3C XMLDSIG WG
> which I believe was reasonably successful.

---

From: "Patrik Fältström" <[email-masked]>
Date: Thu, 31 May 2018 21:31:45 +0200

On 31 May 2018, at 19:22, Nico Williams wrote:

> Certainly, in the context of Internet protocols, the IETF is the place to do I18N work.  Can there be any doubt?

From my personal view, a crystal clear "NO" (part from coordination with W3C of course).

But that is something I think IETF should ask itself and decide that is the case, and act accordingly. Whatever that means. If I knew, I would say...

   paf

---

From: "Patrik Fältström" <[email-masked]>
Date: Thu, 31 May 2018 21:33:03 +0200

On 31 May 2018, at 20:04, Donald Eastlake wrote:

> I disagree. I was co-chair of the joint IETF/W3C XMLDSIG WG which I believe was reasonably successful.

Yes but...

It worked when/because of/thanks to good synchronisation on who did what work and who had the lead etc. And the work was done when we where in a different time...

   paf

---

From: Spencer Dawkins at IETF <[email-masked]>
Date: Thu, 31 May 2018 15:53:34 -0500

On Thu, May 31, 2018 at 2:34 PM Patrik Fältström <[email-masked]> wrote:

> But that is something I think IETF should ask itself and decide that is
> the case, and act accordingly.
>

I've read through this thread carefully enough to say that if a BOF
description in this space showed up in
https://trac.tools.ietf.org/bof/trac/wiki, I'd most likely encourage the
IESG to approve it.

I'm not ready to convince myself that this is a TSV BOF and I should
sponsor it, but we do have 13 ADs who aren't TSV ADs ...

Do the right thing.

Spencer

---

From: Adam Roach <[email-masked]>
Date: Thu, 31 May 2018 22:33:27 -0500

> It worked when/because of/thanks to good synchronisation on who did what work and who had the lead etc. And the work was done when we where in a different time...

If you need something more time-local, WebRTC/RTCWEB was likewise a 
joint W3C/IETF effort. As in your description, though, it seems that a 
good understanding of scoping and responsibilities between the groups 
was a key to success.

/a

---

From: Nico Williams <[email-masked]>
Date: Thu, 31 May 2018 23:03:36 -0500

On Thu, May 31, 2018 at 09:31:45PM +0200, Patrik Fältström wrote:
> But that is something I think IETF should ask itself and decide that
> is the case, and act accordingly. Whatever that means. If I knew, I
> would say...

Who else will do I18N work on Internet protocols?  Either we give them
to other SDOs or we do the work.

Nico
--

---

From: Nico Williams <[email-masked]>
Date: Thu, 31 May 2018 23:19:50 -0500

> competence. However, this is something we could discuss at the BoF.

Once I knew nothing about I18N.  Then I learned (plenty).  I'm not
saying I'm more expert than anyone else here, but I am saying that I
learned.

Can everyone else not??  What lack of faith you are all displaying!

I mean, here's how you do this:

a) you get a couple of ADs with I18N experience,
b) also someone on the IAB with I18N experience,
c) add a mandate for an I18N Considerations section,
d) add an I18N directorate.

Does that not sound familiar?

I mean, this "we lack expertise in field X" thing is remarkably silly.
I bet not that long ago that was said about security...

I'm sure we're still not great, collectively, on security, but we don't
just give up on security.  We didn't, and we won't.

Is anyone here saying I18N is more difficult than security?  Seriously?
Do you think that people who can build complex Internet protocols cannot
figure out I18N even passably well enough?

What areas does the IETF have expertise in?  Please list them.  I bet
none are much simpler than I18N.  The Internet has become critical to
the world's economy and we are responsible for not ****ing that up, but
we can't handle I18N?!

No, please buck up, get a spine transplant, set down some rules, and
watch participants figure it out.  It may not turn out to be fantastic,
but it will mostly get the job done well enough.

Dumbfoundedly yours,

Nico

PS: Really, I'm shocked at this thread.  I don't get it.  What series of
    events is causing the sad, utter despair on display here?  I've not
    been following the IETF all that much, so it's possible I missed
    some disasters.  Can they have been so bad?  Please fill me in on
    them.

    The abdication mood here is depressing.

---

From: Brian E Carpenter <[email-masked]>
Date: Fri, 1 Jun 2018 16:39:53 +1200

As an ignoramus on these matters, I've been keeping quiet, but...
>> From my personal view, a crystal clear "NO" (part from coordination

I really don't understand how that can be true for protocols that
are developed or maintained in the IETF, that are of no interest to
the W3C, and require some sensible handling of I18N issues. To my mind
that certainly includes any protocol that involves text strings of
interest to humans, including names of interest to humans.

> to other SDOs or we do the work.

Exactly. And the PRECIS work made it clear to me that a simple sprinkling
of pixie dust is not enough. I think John is quite right to ring the alarm
bell.

We did a tutorial 8 IETFs ago:
https://www.ietf.org/about/participate/tutorials/technical/precis-i18n/

Since then?

    Brian

---

From: Larry Masinter <[email-masked]>
Date: Fri, 1 Jun 2018 04:51:48 +0000

A modest proposal (I'm sure this is controversial so flame away...)

A big part of the problems in i18n in IETF protocols have to do with extending protocol elements from ASCII to Unicode, and how to avoid difficulties when that happens. 

Protocol elements include domain names, URLs, email addresses, file names

But where do these Unicode names come from? They're not arbitrarily generated by automated processes, they're constructed from strings that are selected, typed in, registered. So focus on encouraging people to choose strings that won't give problems. 

A large specification of all of the use cases to avoid is very difficult to write and hard to review. There are very many special cases (final sigma, umlauts, private name characters, non-normalization of combined forms) with expertise widely distributed. I'm not sure the solution is "more specs"; in fact, there are many obscure special cases, and the specs are very difficult to write and review.

I wonder if there's any interest in building an open-source service that would, when given a proposed domain name or URL or email address, tell you what problems various subsets of users would have when trying to deploy that name (e.g., names that don't display properly on popular platforms, names that can't be reliably typed in correctly even if they can be viewed, those that are likely to get confused with other similar but different names).

Perhaps get started at a Hackathon? 

I did reserve the domain name "caniuse.name" that I will offer to any sincere effort.

---

From: "Patrik Fältström" <[email-masked]>
Date: Fri, 01 Jun 2018 07:46:36 +0200

On 1 Jun 2018, at 6:19, Nico Williams wrote:

> PS: Really, I'm shocked at this thread.  I don't get it.  What series of    events is causing the sad, utter despair on display here?  I've not

That we have for example:

- Had Unicode/IDNA discussions with comments from very very few people, and I think three that "did send text"
- Had IAB close a directorate on the topic
- Had Precis "just about" get the review they needed to call consensus

This is what I have seen.

So, very very very few people actually "show up" in discussions.

This is why I say "priority" is important.

   paf

---

From: John C Klensin <[email-masked]>
Date: Fri, 01 Jun 2018 02:17:04 -0400

Larry,

Other than disabusing people of ideas that this is easy, I
really do not want to talk about protocol details or solutions.
I want to talk about the procedural issue of how we move
forward, given that we have an interesting array of symptoms,
e.g., 

* drafts have been initiated to address specific and important
problems, or even to start identifying them in depth, and the
IESG (fwiw, I believe correctly but others may not agree) has
been unwilling to address them because there has not appeared to
be sufficient in-depth expertise and energy/ commitment to form
a working group.

* the IAB put together an I18N Program effort to try to get on
top of some of the issues.  I would claim it did some useful
work in its early days, but the IAB shut it down a year ago
after concluding that it wasn't doing anything, had not done
anything for some time, and was showing no signs of that
changing (IAB, if you don't like that summary, suggest another
one, but I think that is reasonably accurate).  That decision
was announced, rather than being discussed with the the
community or even with the set of Program members who were not
on the IAB, something the IAB clearly has the right to do.

* As far as I know, we have no plan to get unstuck from the
above.  I note Nico's suggestion of

> d) add an I18N directorate

And note that we've had ADs and IAB members with I18N experience
and it hasn't appeared to make any long-term difference, that
there have been efforts to explain the importance of these
issues to several recent Nomcoms and either they could find no
candidates with significant levels of the right skills or they
didn't consider the issues very important.   We've also had a
mandate for what was then called "multilingual Considerations"
for over 20 years (see Section 8.1(I) of RFC 2130).   That IAB
Program wasn't a directorate as we usually define the term, but
it had a lot of the same properties.

I'm not interested in casting blame, but comparing that list
with things we have tried already certainly reinforces my sense
that we have gotten stuck.  Or, if you prefer, that we are at
the bottom of a hole and all we can think to do is to stand
there and do nothing or keep digging.

Relative to your proposal I also note that we made decisions
(also more or less referred to in RFC 2130 that actual protocol
elements should stay in ASCII unless they was compelling reason
to "internationalize" them.  We've learned a lot since then and
the world has changed, but, at least IMO, we have never really
reexamined that principle.   As to an "identify which names can
cause problems" service, that has been tried too.  A number of
script-specific efforts, starting with the JET work reflected in
RFC 3743 and extending forward to include at least ICANN's LGR
effort, have focused on identifying characters (or Unicode code
points) that might be problematic in various ways and
combinations.  Others have looked at potentially confusing
relationships, both due to accidental confusion (hard problem
for the general case) and malice (nearly impossible case, IMO).
It just simply isn't as easy as you think, especially if the
IETF does not abandon the principle that we will not go through
Unicode one code point at a time looking for problems, possibly
in comparison with every other code point.   It may also be
worth pointing out that one of the "stuck" (and now-expired)
drafts was devoted to the identification of troublesome code
points.   This simply isn't as easy as whipping up a few
programs ... and getting consensus that those programs do the
right thing (even more or less) would be very difficult because
counterexamples keep coming out of the proverbial woodwork or
crawling out from under proverbial rocks.

Personally, I think that "troublesome character" approach would
be helpful as long as we can be very clear about its
limitations, including remembering that it isn't the Final
Ultimate Solution to anything or a replacement for skilled and
knowledgeable human judgment, and we can figure out a reliable
and sustainable way to maintain the table.  We don't have an
obvious way forward with either of those requirements and that
is, again, a reason I thought this discussion was worth starting.

best,
    john

--On Friday, June 1, 2018 04:51 +0000 Larry Masinter
<[email-masked]> wrote:

> A big part of the problems in i18n in IETF protocols have to
> do with extending protocol elements from ASCII to Unicode, and
> how to avoid difficulties when that happens. 
> 
> But where do these Unicode names come from? They're not
> arbitrarily generated by automated processes, they're
> constructed from strings that are selected, typed in,
> registered. So focus on encouraging people to choose strings
> that won't give problems. 
> 
> A large specification of all of the use cases to avoid is very
> difficult to write and hard to review. There are very many
> special cases (final sigma, umlauts, private name characters,
> non-normalization of combined forms) with expertise widely
> distributed. I'm not sure the solution is "more specs"; in
> fact, there are many obscure special cases, and the specs are
> very difficult to write and review.
> 
> I wonder if there's any interest in building an open-source
> service that would, when given a proposed domain name or URL
> or email address, tell you what problems various subsets of
> users would have when trying to deploy that name (e.g., names
> that don't display properly on popular platforms, names that
> can't be reliably typed in correctly even if they can be
> viewed, those that are likely to get confused with other
> similar but different names).
>